package hu.bme.mit.books.e4.app.handlers;

import javax.inject.Named;

import hu.bme.mit.books.manager.IBookManager;
import hu.bme.mit.books.model.Book;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.services.IServiceConstants;

public class RemoveBookHandler {
	@Execute
	public void execute(IBookManager manager, 
			@Optional@Named(IServiceConstants.ACTIVE_SELECTION) Book book) {
		if (book != null) {
			manager.removeBook(book);
		}
	}

	@CanExecute
	public boolean canExecute(@Optional@Named(IServiceConstants.ACTIVE_SELECTION) Book book) {
		return book != null;
	}

}