package hu.bme.mit.books.model.test;

import static org.junit.Assert.*;
import hu.bme.mit.books.manager.BookManager;
import hu.bme.mit.books.manager.IBookManager;
import hu.bme.mit.books.model.Book;

import java.util.List;

import org.junit.Before;
import org.junit.Test;

public class BookManagerTests {

	IBookManager manager;

	@Before
	public void setUp() {
		manager = new BookManager();
		manager.addBook("Terry Pratchett", "The Light Fantastic", 232, true);
		manager.addBook("Terry Pratchett", "The Color of Magic", 232, true);
		manager.addBook("Neil Gaiman", "American Gods", 560, true);
		manager.addBook("Test author", "Test Book", 123, false);
	}

	@Test
	public void addBook() {
		int oldSize = manager.getAllBooks().size();
		manager.addBook("Test Author", "Test Title", 112, false);
		int newSize = manager.getAllBooks().size();
		assertSame(newSize, oldSize + 1);
	}

	@Test
	public void filterBooksSingleBook() {
		List<Book> books = manager.getBookOfAuthor("Neil Gaiman");
		int size = books.size();
		assertSame(size, 1);
	}

	@Test
	public void filterBookMultipleBooks() {
		List<Book> books = manager.getBookOfAuthor("Terry Pratchett");
		int size = books.size();
		assertSame(size, 2);
	}

	@Test(expected = IllegalArgumentException.class)
	public void filterBookEmptyAuthor() {
		manager.getBookOfAuthor("");
	}
}
